//+------------------------------------------------------------------+
//|                                                             mama |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  DeepSkyBlue 
#property indicator_color2  PaleVioletRed
#property indicator_color3  LimeGreen
#property indicator_color4  LimeGreen
#property indicator_color5  Red
#property indicator_color6  Red
#property indicator_color7  DimGray
#property indicator_style4  STYLE_DOT
#property indicator_style5  STYLE_DOT
#property indicator_style7  STYLE_DOT
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuyP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
#import

//
//
//
//
//

extern double FastLimit               = 0.5;
extern double SlowLimit               = 0.05;
extern int    Price                   = PRICE_MEDIAN;
extern bool   ShowMiddleLine          = true;
extern int    DzLookBackBars          = 50;
extern double DzStartBuyProbability1  = 0.10;
extern double DzStartBuyProbability2  = 0.25;
extern double DzStartSellProbability1 = 0.10;
extern double DzStartSellProbability2 = 0.25;

//
//
//
//
//

double mama[];
double fama[];
double bl1Buffer[];
double bl2Buffer[];
double sl1Buffer[];
double sl2Buffer[];
double zliBuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,mama);
   SetIndexBuffer(1,fama);
   SetIndexBuffer(2,bl1Buffer); 
   SetIndexBuffer(3,bl2Buffer); 
   SetIndexBuffer(4,sl2Buffer); 
   SetIndexBuffer(5,sl1Buffer); 
   SetIndexBuffer(6,zliBuffer);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][13];
#define _price     0
#define _smooth    1
#define _detrender 2
#define _period    3
#define _phase     4
#define _Q1        5
#define _I1        6
#define _JI        7
#define _JQ        8
#define _Q2        9
#define _I2       10
#define _Re       11
#define _Im       12

#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

int start()
{
   double rad2degree = 180.0/Pi;
   int    i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
            if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][_price]     = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      work[r][_smooth]    = (4.0*work[r][_price]+3.0*work[r-1][_price]+2.0*work[r-2][_price]+work[r-3][_price])/10.0;
      work[r][_detrender] = calcComp(r,_smooth);
      work[r][_Q1]        = calcComp(r,_detrender);
      work[r][_I1]        = work[r-3][_detrender];
      work[r][_JI]        = calcComp(r,_I1);
      work[r][_JQ]        = calcComp(r,_Q1);
      
      //
      //
      //
      //
      //
      
      work[r][_I2] = 0.2*(work[r][_I1]-work[r][_JQ])                                 + 0.8*work[r-1][_I2];
      work[r][_Q2] = 0.2*(work[r][_Q1]+work[r][_JI])                                 + 0.8*work[r-1][_Q2];
      work[r][_Re] = 0.2*(work[r][_I2]*work[r-1][_I2] + work[r][_Q2]*work[r-1][_Q2]) + 0.8*work[r-1][_Re];
      work[r][_Im] = 0.2*(work[r][_I2]*work[r-1][_Q2] - work[r][_Q2]*work[r-1][_I2]) + 0.8*work[r-1][_Im];
      
      if (work[r][_Re]!= 0 && work[r][_Im]!=0) 
          work[r][_period] = 360.0/(MathArctan(work[r][_Im]/work[r][_Re])*rad2degree);
          work[r][_period] = MathMin(work[r][_period],1.50*work[r-1][_period]);
          work[r][_period] = MathMax(work[r][_period],0.67*work[r-1][_period]);
          work[r][_period] = MathMin(MathMax(work[r][_period],6),50);
          work[r][_period] = 0.2*work[r][_period]+0.8*work[r-1][_period];
      
      //
      //
      //
      //
      //
      
      if( work[r][_I1] != 0) work[r][_phase] = MathArctan(work[r][_Q1]/work[r][_I1])*rad2degree;
	
                  double DeltaPhase = MathMax(work[r-1][_phase]-work[r][_phase],1);
                  double Alpha      = MathMax(MathMin(FastLimit/DeltaPhase,FastLimit),SlowLimit);
	
      mama[i] =     Alpha*work[r][_price] + (1.0-    Alpha)*mama[i+1];
      fama[i] = 0.5*Alpha*mama[i]         + (1.0-0.5*Alpha)*fama[i+1];
      
      if (DzStartBuyProbability1 >0) bl1Buffer[i] = dzBuyP (mama, DzStartBuyProbability1,  DzLookBackBars, Bars, i, 0.0001);
      if (DzStartBuyProbability2 >0) bl2Buffer[i] = dzBuyP (mama, DzStartBuyProbability2,  DzLookBackBars, Bars, i, 0.0001);
      if (DzStartSellProbability1>0) sl1Buffer[i] = dzSellP(mama, DzStartSellProbability1, DzLookBackBars, Bars, i, 0.0001);
      if (DzStartSellProbability2>0) sl2Buffer[i] = dzSellP(mama, DzStartSellProbability2, DzLookBackBars, Bars, i, 0.0001);
      if (ShowMiddleLine)            zliBuffer[i] = dzSellP(mama, 0.5                    , DzLookBackBars, Bars, i, 0.0001);
    
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double calcComp(int r, int from)
{
   return((0.0962*work[r  ][from] + 
           0.5769*work[r-2][from] - 
           0.5769*work[r-4][from] - 
           0.0962*work[r-6][from]) * (0.075*work[r-1][_period] + 0.54));
}